#ifndef __NuEdu_Basic01_PWM_Capture_H__
#define __NuEdu_Basic01_PWM_Capture_H__

#define	_PWM_Source_Clock	12000000		//XTAL's 12 MHz
#define	_PWM_Resolution		65536
#define	_PWM_Prescale_Max	256
#define _PWM_Duty_Scale		100				//0 ~ 100 %

typedef struct
{
	__IO uint32_t Capture_Rising[2];
	__IO uint32_t Capture_Falling[2];
	__IO uint32_t Last_Edge;
	__IO uint32_t High_Period;
	__IO uint32_t Low_Period;
	__IO uint32_t Signal_Period;
	__IO float Signal_Frequency;
} PWM_Capture_T;

typedef enum 
{
	Rising = 0,
	Falling = 1
} E_Edge;

extern uint32_t PWM67_Clock;
extern uint32_t Open_PWM6_OUT_Fail;
extern uint32_t Open_PWM3_Capture_Fail;
extern uint32_t Open_PWM7_Capture_Fail;
extern PWM_Capture_T PWM3;
extern PWM_Capture_T PWM7;

void Open_PWM6_OUT(uint32_t PWM_Frequency, uint32_t PWM_Duty);
void Close_PWM6_OUT(void);

void Open_PWM7_Capture(void);
void Close_PWM7_Capture(void);
void Get_PWM7_Capture_Data(void);

void Open_PWM3_Capture(void);
void Close_PWM3_Capture(void);
void Get_PWM3_Capture_Data(void);


#endif
