#include <stdio.h>
#include "NUC200Series.h"
#include "NuEdu-Basic01_ClkOut.h"

uint32_t Open_CLK_OUT_Fail = FALSE;


void Open_CLK_OUT(uint32_t Clock_Source, uint32_t FRQDIV_FSEL)
{
	Open_CLK_OUT_Fail = FALSE;
	
	//Initial CLKO Function Pin
	SYS->GPB_MFP = (SYS->GPB_MFP & ~SYS_GPB_MFP_PB8_Msk) | SYS_GPB_MFP_PB8_CLKO;
	SYS->ALT_MFP = (SYS->ALT_MFP & ~SYS_ALT_MFP_PB8_Msk) | SYS_ALT_MFP_PB8_CLKO;

	//Initial CLKO Clock Source
	SYS_UnlockReg();
	if(!(SYSCLK->PWRCON&SYSCLK_PWRCON_IRC22M_EN_Pos))
	{
		SYSCLK->PWRCON = SYSCLK_PWRCON_IRC22M_EN_Msk;					//Enable IRC's 22.1184 MHz
		while(!(SYSCLK->CLKSTATUS&SYSCLK_CLKSTATUS_IRC22M_STB_Msk));
		SystemCoreClockUpdate();
	}
	if(!(SYSCLK->PWRCON&SYSCLK_PWRCON_XTL12M_EN_Msk))
	{
		SYSCLK->PWRCON = SYSCLK_PWRCON_XTL12M_EN_Msk;					//Enable XTAL's 12 MHz
		while(!(SYSCLK->CLKSTATUS&SYSCLK_CLKSTATUS_XTL12M_STB_Msk));
		SystemCoreClockUpdate();
	}
	if(!(SYSCLK->PWRCON&SYSCLK_PWRCON_XTL32K_EN_Msk))
	{
		SYSCLK->PWRCON = SYSCLK_PWRCON_XTL32K_EN_Msk;					//Enable XTAL's 32 MHz
		while(!(SYSCLK->CLKSTATUS&SYSCLK_CLKSTATUS_XTL32K_STB_Msk));
		SystemCoreClockUpdate();
	}

	SYSCLK->CLKSEL2 = (SYSCLK->CLKSEL2 & ~SYSCLK_CLKSEL2_FRQDIV_S_Msk) | Clock_Source;
	SYSCLK->APBCLK |= SYSCLK_APBCLK_FDIV_EN_Msk;
	SYS_LockReg();
	
	if(FRQDIV_FSEL>15)
	{
		Open_CLK_OUT_Fail = TRUE;
		FRQDIV_FSEL = 15;
		printf("\nOpen CLK OUT FAIL\n");
	}
	
	//Initial CLKO Clock Divider
	SYSCLK->FRQDIV = SYSCLK_FRQDIV_DIVIDER_EN_Msk | FRQDIV_FSEL;
	
//	if(Open_CLK_OUT_Fail==FALSE)
//		printf("\nOpen CLK_OUT Success!\n");
}

void Close_CLK_OUT(void)
{
	//Close CLKO Function Pin
	SYS->GPB_MFP &= ~SYS_GPB_MFP_PB8_Msk;
	SYS->ALT_MFP &= ~SYS_ALT_MFP_PB8_Msk;

	//Disable CLKO Function
	SYSCLK->FRQDIV &= ~SYSCLK_FRQDIV_DIVIDER_EN_Msk;

	//Close PWM Clock Source
	SYS_UnlockReg();
    SYSCLK->APBCLK &= ~SYSCLK_APBCLK_FDIV_EN_Msk;
	SYS_LockReg();
}
