#include <stdio.h>
#include "NUC200Series.h"
#include "NuEdu-Basic01_Timer_Ouput_Capture.h"

void Initial_Timer_port(void)
{	
	
	
/* Set PB multi-function pins for UART0 RXD, UART0 TXD; TMR0 ~ TMR3 external counter pins; TMR0, TMR2 and TMR3 external capture pins */
 SYS->GPB_MFP |= SYS_GPB_MFP_PB10_TM2 |SYS_GPB_MFP_PB3_T3EX;
	
/* Set ALT MPF settings for TMR0 ~ TMR3 external counter and capture functions */
    SYS->ALT_MFP |= SYS_ALT_MFP_PB10_TM2|SYS_ALT_MFP_PB3_T3EX;

    /* Set ALT MPF1 settings for TMR3 external capture */
    SYS->ALT_MFP1 |= SYS_ALT_MFP1_PB3_T3EX;
}

void initial_Timer_Toggle(void)
{
 /* Enable IP clock */        
    //SYSCLK->APBCLK |= SYSCLK_APBCLK_TMR2_EN_Msk | SYSCLK_APBCLK_TMR3_EN_Msk;

    //SYSCLK->CLKSEL1 |= SYSCLK_CLKSEL1_TMR2_HCLK | SYSCLK_CLKSEL1_TMR3_HCLK;
    SYSCLK->APBCLK |= SYSCLK_APBCLK_TMR2_EN_Msk;

    SYSCLK->CLKSEL1 |= SYSCLK_CLKSEL1_TMR2_HCLK;
	
      /* Reset and stop , TIMER2   counting first */

    _TIMER_RESET(TIMER2);
 	
	    /* Configure TCMP values of TIMER0 and TIMER3 */
    TIMER2->TCMPR = (__XTAL/1000);  // For 1000Hz (Equal to 500Hz toggle rate)
    
    /* Start TIMER0 counting and output T0 frequency - 500 Hz*/
    TIMER2->TCSR = TIMER_TCSR_CEN_Msk | TIMER_TCSR_MODE_TOGGLE | TIMER_TCSR_TDR_EN_Msk | TIMER_TCSR_PRESCALE(1);    
}


void initial_Timer_count(void)
{
 /* Enable IP clock */        
    SYSCLK->APBCLK |= SYSCLK_APBCLK_TMR2_EN_Msk;

    SYSCLK->CLKSEL1 |= SYSCLK_CLKSEL1_TMR2_HCLK;
	
      /* Reset and stop , TIMER2   counting first */

    _TIMER_RESET(TIMER2);
 	
	    /* Configure TCMP values of TIMER0 and TIMER3 */
    TIMER2->TCMPR = (__XTAL/1000);  // For 1000Hz (Equal to 500Hz toggle rate)
    
    /* Start TIMER0 counting and output T0 frequency - 500 Hz*/
    TIMER2->TCSR = TIMER_TCSR_CEN_Msk | TIMER_TCSR_MODE_TOGGLE | TIMER_TCSR_TDR_EN_Msk |TIMER_TCSR_CTB_ENABLE | TIMER_TCSR_PRESCALE(1);    
}

void initial_Timer_capture(void)
{
 /* Enable IP clock */        
    SYSCLK->APBCLK |= SYSCLK_APBCLK_TMR3_EN_Msk;

    SYSCLK->CLKSEL1 |= SYSCLK_CLKSEL1_TMR3_HCLK;
	
      /* Reset and stop , TIMER2   counting first */

    _TIMER_RESET(TIMER3);
 	    /* Enable TIMER1 counter and capture function */
    TIMER1->TCMPR = 0xFFFFFF;
    TIMER1->TCSR = TIMER_TCSR_CEN_Msk | TIMER_TCSR_IE_Msk | TIMER_TCSR_MODE_CONTINUOUS | TIMER_TCSR_CTB_ENABLE | 
                      TIMER_TCSR_TDR_EN_Msk | TIMER_TCSR_PRESCALE(1);
    TIMER1->TEXCON = TIMER_TEXCON_MODE_CAP | TIMER_TEXCON_TEXIEN_ENABLE | TIMER_TEXCON_TEXEN_ENABLE;
}